define(['module', 'react'], function (module, _react) {
    'use strict';

    var _react2 = _interopRequireDefault(_react);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var HighlightOverlay = function (_React$Component) {
        _inherits(HighlightOverlay, _React$Component);

        function HighlightOverlay(props) {
            _classCallCheck(this, HighlightOverlay);

            var _this = _possibleConstructorReturn(this, (HighlightOverlay.__proto__ || Object.getPrototypeOf(HighlightOverlay)).call(this, props));

            _this.updateWindowSize = function () {
                var _this$getBodySize = _this.getBodySize(),
                    width = _this$getBodySize.width,
                    height = _this$getBodySize.height;

                _this.setState({
                    width: width,
                    height: height
                });
            };

            _this.componentDidUpdate = function () {
                _this.updateCanvas();
            };

            _this.getBodySize = function () {
                return document.body.getBoundingClientRect();
            };

            _this.updateCanvas = function () {
                var context = _this.refs.canvas.getContext('2d');
                context.save();

                _this.drawBackground(context);

                context.globalCompositeOperation = 'destination-out';

                for (var index = 0; index < _this.props.targets.length; index++) {
                    _this.drawHighlight(context, _this.props.targets[index]);
                }

                context.restore();
            };

            _this.drawBackground = function (context) {
                var _this$getBodySize2 = _this.getBodySize(),
                    width = _this$getBodySize2.width,
                    height = _this$getBodySize2.height;

                context.clearRect(0, 0, width, height);

                context.beginPath();
                context.rect(0, 0, width, height);
                context.fillStyle = _this.props.backgroundColor;
                context.fill();
            };

            _this.drawHighlight = function (context, target) {
                var targetObject = document.querySelector(target);

                if (!targetObject) {
                    setTimeout(function () {
                        _this.drawHighlight(context, target);
                    }, 200);
                    return;
                }

                var _targetObject$getBoun = targetObject.getBoundingClientRect(),
                    top = _targetObject$getBoun.top,
                    left = _targetObject$getBoun.left,
                    width = _targetObject$getBoun.width,
                    height = _targetObject$getBoun.height;

                context.beginPath();
                context.rect(left, top, width, height);
                context.fillStyle = 'white';
                context.fill();
            };

            _this.render = function () {
                return _react2.default.createElement('canvas', {
                    ref: 'canvas',
                    width: _this.state.width,
                    height: _this.state.height,
                    style: {
                        top: 0,
                        left: 0,
                        position: 'absolute',
                        zIndex: _this.props.zIndex
                    }
                });
            };

            _this.state = {
                width: 0,
                height: 0
            };
            return _this;
        }

        _createClass(HighlightOverlay, [{
            key: 'componentDidMount',
            value: function componentDidMount() {
                var _this2 = this;

                this.updateWindowSize();
                window.onresize = function () {
                    return _this2.updateWindowSize();
                };
            }
        }]);

        return HighlightOverlay;
    }(_react2.default.Component);

    HighlightOverlay.propTypes = {
        targets: _react2.default.PropTypes.array,
        zIndex: _react2.default.PropTypes.number,
        backgroundColor: _react2.default.PropTypes.string
    };

    HighlightOverlay.defaultProps = {
        targets: [],
        zIndex: 1400,
        backgroundColor: 'rgba(0, 0, 0, 0.6)'
    };

    module.exports = HighlightOverlay;
});